# frozen_string_literal: true

module FsmEngine
  # finite state machine
  class Fsm
    attr_accessor :cur_rule, :rules

    def initialize(rules)
      @rules = {}
      @history = []
      rules.each do |rule|
        self.rules[rule.cur_condition] = rule
      end
      @cur_rule = rules.first
    end

    def start(condition)
      results = []

      while (self.cur_rule = rules[condition])
        result = cur_rule.action.call
        results.push({ condition: condition, result: result })
        condition = cur_rule.next_condition
      end

      results
    end
  end
end
